org.eclipse.aether.util.graph.transformer

## Class ConflictResolver.VersionSelector

- java.lang.Object
- - org.eclipse.aether.util.graph.transformer.ConflictResolver.VersionSelector

- Direct Known Subclasses:
    NearestVersionSelector
  Enclosing class:
    ConflictResolver

      public abstract static class ConflictResolver.VersionSelector
      extends Object

  An extension point of `ConflictResolver` that determines the winner among conflicting dependencies. The winning node (and its children) will be retained in the dependency graph, the other nodes will get removed. The version selector does not need to deal with potential scope conflicts, these will be addressed afterwards by the `ConflictResolver.ScopeSelector`. Implementations must be stateless.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConflictResolver.VersionSelector()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ConflictResolver.VersionSelector` | `getInstance(DependencyNode root, DependencyGraphTransformationContext context)` Retrieves the version selector for use during the specified graph transformation.
    `abstract void` | `selectVersion(ConflictResolver.ConflictContext context)` Determines the winning node among conflicting dependencies.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ConflictResolver.VersionSelector

          public ConflictResolver.VersionSelector()

  - ### Method Detail

    - #### getInstance

          public ConflictResolver.VersionSelector getInstance(DependencyNode root,
                                                     DependencyGraphTransformationContext context)
                                                       throws RepositoryException

      Retrieves the version selector for use during the specified graph transformation. The conflict resolver calls this method once per `ConflictResolver.transformGraph(DependencyNode, DependencyGraphTransformationContext)` invocation to allow implementations to prepare any auxiliary data that is needed for their operation. Given that implementations need to be stateless, a new instance needs to be returned to hold such auxiliary data. The default implementation simply returns the current instance which is appropriate for implementations which do not require auxiliary data.
      Parameters:
        `root` - The root node of the (possibly cyclic!) graph to transform, must not be `null`.
        `context` - The graph transformation context, must not be `null`.
      Returns:
        The scope deriver to use for the given graph transformation, never `null`.
      Throws:
        `RepositoryException` - If the instance could not be retrieved.

    - #### selectVersion

          public abstract void selectVersion(ConflictResolver.ConflictContext context)
                                      throws RepositoryException

      Determines the winning node among conflicting dependencies. Implementations will usually iterate `ConflictResolver.ConflictContext.getItems()`, inspect `ConflictResolver.ConflictItem.getNode()` and eventually call `ConflictResolver.ConflictContext.setWinner(ConflictResolver.ConflictItem)` to deliver the winner. Failure to select a winner will automatically fail the entire conflict resolution.
      Parameters:
        `context` - The conflict context, must not be `null`.
      Throws:
        `RepositoryException` - If the version selection failed.

Copyright © 2010-2013 The Eclipse Foundation. All Rights Reserved.